#include <stdio.h>
#include <stdlib.h>

/* Configuration options */

/* Size of each stack frame */
#define STACK_SIZE 256

/* Type to use for stack cells. Should be >= fungespace cells in size */
#define STACK_TYPE signed long

/* Type to use for fungespace cells */
#define CELL_TYPE unsigned char

typedef struct _bstack {
	STACK_TYPE stack[STACK_SIZE];
	struct _bstack *next;
} bstack;

bstack *stack = (bstack *) NULL;
signed long pos = 0; /* Location of next free entry in current stack frame */

CELL_TYPE space[80][25];

STACK_TYPE popcell()
{
	bstack *s;
	if (stack == 0)
		return 0;
	if (pos == 0)
	{
		if (stack->next) /* Any more stack frames? */
		{
			s = stack;
			stack = stack->next;
			pos+=STACK_SIZE;
			free(s);
		}
		else
			return 0; /* No stack */
	}
	pos--;
	return stack->stack[pos];
}

void pushcell(STACK_TYPE v)
{
	bstack *s;
	if (stack == 0)
	{
		stack = (bstack *) malloc(sizeof(bstack));
		stack->next = 0;
	}
	stack->stack[pos++] = v;
	if (pos != STACK_SIZE)
		return;
	pos-=STACK_SIZE;
	s = (bstack *) malloc(sizeof(bstack));
	s->next = stack;
	stack = s;
}

STACK_TYPE readspace(STACK_TYPE x,STACK_TYPE y)
{
	if ((x < 0) || (x > 79) || (y < 0) || (y > 24))
		return 32;
	return (STACK_TYPE) space[x][y];
}

void setspace(STACK_TYPE x,STACK_TYPE y,STACK_TYPE v)
{
	if ((x < 0) || (x > 79) || (y < 0) || (y > 24))
		return;
	space[x][y] = (CELL_TYPE) v;
}

void initialise()
{
	int x,y;
	for (x=0;x<80;x++)
		for (y=0;y<25;y++)
			space[x][y] = 32;
	/* Copy initial fungespace from char **initfunge */
	y=0;
	while (initfunge[y][0])
	{
		x=0;
		while (initfunge[y][x])
		{
			setspace(x,y,initfunge[y][x]);
			x++;
		}
		y++;
	}
}
